#include <msp/fs/utils.h>
#include "component.h"
#include "datacollection.h"
#include "datatransform.h"
#include "sourcepackage.h"

using namespace Msp;

DataCollection::DataCollection(Builder &b, const Component &c, DataTransform &s):
	FileTarget(b, c.get_package(), generate_target_path(c, s.get_path())),
	source(s)
{
	component = &c;
	add_dependency(source);
}

Msp::FS::Path DataCollection::generate_target_path(const Component &comp, const Msp::FS::Path &src)
{
	return comp.get_package().get_temp_directory()/comp.get_name()/(FS::basepart(FS::basename(src))+".mdc");
}

void DataCollection::find_dependencies()
{
	source.prepare();
	const Target::Dependencies &tdeps = source.get_transitive_dependencies();
	for(Target::Dependencies::const_iterator i=tdeps.begin(); i!=tdeps.end(); ++i)
		add_dependency(**i);
}
